/*
TASK: square
LANG: C++
*/

#include <cstdio>
#include <queue>

#define ABS(x) ( (x) < 0 ? -(x) : (x) )

#define f(i, n) for(int i = 0; i < (n); i ++)
#define ff(i, st, end) for(int i = (st); i < (end); i ++)
#define fv(i, v) for(int i = 0; i < int((v).size()); i ++)
#define fx(i, v) for(typeof( (v).begin() ) it = (v).begin(); it != (v).end(); it ++)
#define all(v) (v).begin(), (v).end()

int n;
int X[1005][4], Y[1005][4];


inline int cp(int x1, int y1, int x2, int y2, int x3, int y3)
{
	return (x2 - x1) * (y3 - y1) - (x3 - x1) * (y2 - y1);
}

inline bool in(int x1, int y1, int ind)
{
	int CP[4];
	f(i, 4) CP[i] = ABS(cp( x1, y1, X[ind][i], Y[ind][i], X[ind][i + 1 & 3], Y[ind][i + 1 & 3] ));
	int S =	(X[ind][2] - X[ind][1]) * ((X[ind][2] - X[ind][1])) 
		+	(Y[ind][2] - Y[ind][1]) * ((Y[ind][2] - Y[ind][1]));
	if( (CP[0]) && (CP[1]) && (CP[2]) && (CP[3]) && (CP[0] + CP[1] + CP[2] + CP[3] == 2 * S) )
		return 1;
	return 0;
}

inline bool inBorder(int x1, int y1, int ind)
{
	int CP[4];
	f(i, 4) CP[i] = ABS(cp( x1, y1, X[ind][i], Y[ind][i], X[ind][i + 1 & 3], Y[ind][i + 1 & 3] ));
	int S =	(X[ind][2] - X[ind][1]) * ((X[ind][2] - X[ind][1])) 
		+	(Y[ind][2] - Y[ind][1]) * ((Y[ind][2] - Y[ind][1]));
	if(CP[0] + CP[1] + CP[2] + CP[3] == 2 * S) 
		return 1;
	return 0;
}

inline bool inBorder1(int indX, int num, int ind)
{
	int CP[4];
	f(i, 4) CP[i] = ABS(cp( X[indX][num], Y[indX][num], X[ind][i], Y[ind][i], X[ind][i + 1 & 3], Y[ind][i + 1 & 3] ));
	int S =	(X[ind][2] - X[ind][1]) * ((X[ind][2] - X[ind][1])) 
		+	(Y[ind][2] - Y[ind][1]) * ((Y[ind][2] - Y[ind][1]));
	if( (CP[0] + CP[1] + CP[2] + CP[3] == 2 * S) &&
	 	cp( X[indX][num], Y[indX][num], X[ind][num + 2 & 3], Y[ind][num + 2 & 3], X[ind][num + 1 & 3], Y[ind][num + 1 & 3] ) &&
	 	cp( X[indX][num], Y[indX][num], X[ind][num + 2 & 3], Y[ind][num + 2 & 3], X[ind][num + 3 & 3], Y[ind][num + 3 & 3] ))
		return 1;
	return 0;
}

bool g[1005][1005];

bool used[1005];
int dist[1005];
int bfs()
{
	std :: queue<int> q;
	q.push(0);
	used[0] = 1;
	while(!q.empty())
	{
		int cur = q.front(); q.pop();
		for(int i = 0 ; i < n; i ++)
			if( g[cur][i] && (used[i] == 0) )
			{
				q.push(i);
				used[i] = 1;
				dist[i] = dist[cur] + 1;
				if(i == n - 1)	return dist[i];
			}
	}
	return -1;
}

int main()
{
	scanf("%d", &n);
	f(i, n)
	{
		int cx, cy, ax, ay, x, y;
		scanf("%d %d %d %d", &cx, &cy, &ax, &ay);
		x = ABS(cx - ax);
		y = ABS(cy - ay);
		X[i][0] = cx - x; X[i][2] = cx + x; X[i][1] = cx + y; X[i][3] = cx - y;
		Y[i][0] = cy - y; Y[i][2] = cy + y; Y[i][1] = cy - x; Y[i][3] = cy + x;
	}
	
	f(i, n)	f(j, n) if(i != j)
	{
		f(k, 4) if( in( X[i][k], Y[i][k], j ) )
			g[i][j] = g[j][i] = 1;
		if( (X[i][2] - X[i][1] == X[j][2] - X[j][1] ) && 
			(Y[i][2] - Y[i][1] == Y[j][2] - Y[j][1] ) )
			{
				f(k, 4)
					if( inBorder1(i, k, j) )
						g[i][j] = g[j][i] = 1;
			}
//		f(k, 4)	if(inBorder1(i, k, j))	g[i][j] = g[j][i] = 1;
	}
	
//	f(i, n){ f(j, n) printf("%d", g[i][j]); printf("\n"); }
	
	printf("%d\n", bfs());
	
    return 0;
}
