/*
TASK: square
LANG: C++
*/
#include <cstdio>
#include <queue>
#include <vector>

using namespace std;

int n;
vector <int> m[1024];
int used[1024];
int len[1024];

struct sq
{
	int mx,my,rx,ry;
	int vx[5],vy[5];
}mas[1024];

char os(double x1,double y1,double x2,double y2,double x3,double y3)
{
	if(x1*(y2-y3)+x2*(y3-y1)+x3*(y1-y2)>0) return '+';
	return '-'; 
}

bool isin(sq s1,double x,double y)
{
	char o1, o2, o3, o4;
	o1=os(s1.vx[0],s1.vy[0],s1.vx[1],s1.vy[1],x,y);
	o2=os(s1.vx[1],s1.vy[1],s1.vx[2],s1.vy[2],x,y);
	o3=os(s1.vx[2],s1.vy[2],s1.vx[3],s1.vy[3],x,y);
	o4=os(s1.vx[3],s1.vy[3],s1.vx[0],s1.vy[0],x,y);
	if(o1==o2&&o3==o4&&o3==o2) return 1;
	return 0;
}

bool col(sq s1,sq s2)
{
	s1.vx[0]=s1.rx-s1.mx;
	s1.vy[0]=s1.ry-s1.my;
	s1.vx[1]=-s1.vy[0];
	s1.vy[1]=s1.vx[0];
	s1.vx[2]=-s1.vy[1];
	s1.vy[2]=s1.vx[1];
	s1.vx[3]=-s1.vy[2];
	s1.vy[3]=s1.vx[2];
	s1.vx[4]=s1.vy[4]=0;
	
	s2.vx[0]=s2.rx-s2.mx;
	s2.vy[0]=s2.ry-s2.my;
	s2.vx[1]=-s2.vy[0];
	s2.vy[1]=s2.vx[0];
	s2.vx[2]=-s2.vy[1];
	s2.vy[2]=s2.vx[1];
	s2.vx[3]=-s2.vy[2];
	s2.vy[3]=s2.vx[2];
	s2.vx[4]=s2.vy[4]=0;
	
	for(int i=0;i<5;i++)
	{
		s1.vx[i]+=s1.mx;
		s1.vy[i]+=s1.my;
		s2.vx[i]+=s2.mx;
		s2.vy[i]+=s2.my;
	}
	
	int br=0;
	
	for(int i=0;i<5;i++)
	{
		br+=isin(s1,s2.vx[i],s2.vy[i]);
		br+=isin(s2,s1.vx[i],s1.vy[i]);
	}	
	
	for(int i=0;i<4;i++)
	{
		br+=isin(s1,(s2.vx[i]+s2.vx[(i+1)%4])/2,(s2.vy[i]+s2.vy[(i+1)%4])/2);
		br+=isin(s2,(s1.vx[i]+s1.vx[(i+1)%4])/2,(s1.vy[i]+s1.vy[(i+1)%4])/2);
	}
	
	if(br>0) return 1;
	return 0;
	
}

void read()
{
	int amx,amy,arx,ary;
	scanf("%d",&n);
	for(int i=1;i<=n;i++)
	{
		scanf("%d %d %d %d",&amx,&amy,&arx,&ary);
		mas[i].mx=amx;
		mas[i].my=amy;
		mas[i].rx=arx;
		mas[i].ry=ary;
	}
}

void build()
{
	for(int i=2;i<=n;i++)
	{
		for(int j=1;j<i;j++)
		{
			if(col(mas[j],mas[i]))
			{
				m[i].push_back(j);
				m[j].push_back(i);
			}
		}
	}
}

void bfs()
{
	queue <int> q;
	q.push(1);
	used[1]=1;
	len[1]=0;
	int t,siz;
	while(q.empty()==0)
	{
		t=q.front();
		q.pop();
		siz=m[t].size();
		for(int i=0;i<siz;i++)
		{
			if(used[m[t][i]]==0)
			{
				q.push(m[t][i]);
				used[m[t][i]]=1;
				len[m[t][i]]=len[t]+1;
			}
		}
	}
	if(len[n]==0)
	{
		printf("-1\n");
		return ;
	}
	printf("%d\n",len[n]);
}

int main()
{
	read();
	build();
	bfs();
/*	for(int i=1;i<=n;i++)
	{
		printf("%d:",i);
		for(int j=0;j<m[i].size();j++)
		{
			printf(" %d",m[i][j]);
		}
		printf("\n");
	}*/
	return 0;
}
