/*
TASK: square
LANG: C++
*/
#include <iostream>
#define MAXN 1002
using namespace std;
bool data[MAXN][MAXN];
int vert[MAXN];
int n;
struct pt
{
    int x, y;
    // Constructors
    pt () {}
    pt (int _x, int _y) : x(_x), y(_y) {}
    // Rotate
    pt rot () { return pt(-y, x); }
    // Predefine
    pt operator+ (pt a) { return pt(x + a.x, y + a.y); }
    pt operator- (pt a) { return pt(x - a.x, y - a.y); }
};
struct sq { pt o, a[4]; sq() {} } A[MAXN];
void bfs()
{
    int Q[MAXN], f = 0, l = 0, p, i;
    Q[l++] = 0;
    vert[0] = 1;
    while (f < l)
    {
        p = Q[f++];
        for (i = 0; i < n; i++)
        {
            if (!vert[i] && data[p][i])
            {
                Q[l++] = i;
                vert[i] = vert[p]+1;
            }
        }
    }
}
int ort(pt &a, pt &b, pt &c) { return (b.x-a.x)*(c.y-b.y) - (c.x-b.x)*(b.y-a.y); }
inline int sign (int a) { if(a<0) return -1; if(a > 0) return 1; return 0; }
bool comm(pt &a, pt &b, pt &c, pt &d)
{
    if (sign(ort(a,b,c)) * sign(ort(a,b,d)) >= 0) return 0;
    if (sign(ort(c,d,a)) * sign(ort(c,d,b)) >= 0) return 0;
    return 1;
}
bool ptinsqr(pt &p, sq &a)
{
     int i;
     bool s[3]={0,0,0};     
     for (i=0; i<4; i++) s[sign(ort(p,a.a[i],a.a[(i+1)%4]))+1] |= 1;
     if (s[1]) return 0;
     else return s[0]^s[2];
}
bool comm(sq &a, sq &b)
{
     int i, j;
     for(i = 0; i < 4; i++) if (ptinsqr(a.a[i],b)) return true;
     for(i = 0; i < 4; i++) if (ptinsqr(b.a[i],a)) return true;
     for(i = 0; i < 4; i++)
     {
         if (comm(a.a[0],a.a[2],b.a[i],b.a[(i+1)%4])) return true;
         if (comm(a.a[1],a.a[3],b.a[i],b.a[(i+1)%4])) return true;
     }
     for(i = 0; i < 4; i++)
     {
         if(comm(b.a[0],b.a[2],a.a[i],a.a[(i+1)%4])) return true;
         if(comm(b.a[1],b.a[3],a.a[i],a.a[(i+1)%4])) return true;
     }
     for (i = 0; i < 4; i++) for (j = 0; j < 4; j++) if (comm(a.a[i], a.a[(i+1)%4], b.a[j], b.a[(j+1)%4])) return 1;
     return 0;
}
int main ()
{
    cin >> n;
    for(int i = 0; i < n; i++)
    {
        cin >> A[i].o.x >> A[i].o.y >> A[i].a[0].x >> A[i].a[0].y;
        for (int j=1; j<4; j++) A[i].a[j] = A[i].o + (A[i].a[j-1]-A[i].o).rot();
    }
    for(int i = 0; i < n; i++) for (int j = i+1; j < n; j++) if (comm(A[i],A[j])) data[i][j] = data[j][i] = 1;
    bfs();
    cout << vert[n-1]-1 << endl;
    return 0;
}
