/*
TASK: square
LANG: C++
*/
#include <queue>
#include <cstdio>
#include <algorithm>
using namespace std;

const int MAXN = 1 << 10;

int dist ( int x1 , int y1 , int x2 , int y2 ) {
    return (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1);
}

struct el {
    int midx , midy;
    int x1 , y1;
    int x2 , y2;
    int x3 , y3;
    int x4 , y4;
    int d;
    
    void read() {
        scanf ("%d%d",&midx,&midy);
        scanf ("%d%d",&x1,&y1);
        
        x2 = 2 * midx - x1;
        y2 = 2 * midy - y1;
        
        d = dist ( x1 , y1 , midx , midy );
    }
};

int n;
el a[MAXN];

queue < int > q;
int used[MAXN];
int t[MAXN][MAXN];

void read() {
    int i;
    
    scanf ("%d",&n);
    
    for (i=1;i<=n;i++)
        a[i].read();
}

int intersect ( el a , el b ) {
    if ( dist ( a.midx , a.midy , b.midx , b.midy ) <= a.d + b.d ) return 1;
    return 0;
}

void make_graph() {
    int i , j;
    
    for (i=1;i<=n;i++)
        for (j=1;j<=n;j++)
            if ( intersect ( a[i] , a[j] ) ) 
                t[i][j] = t[j][i] = 1;
}

void solve() {
    int x;
    int i;
    
    used[1] = 1;
    q.push ( 1 );
    
    while ( !q.empty() ) {
        x = q.front();
        q.pop();
        
        for (i=1;i<=n;i++) 
            if ( t[x][i] && !used[i] ) {
                used[i] = used[x] + 1;
                q.push ( i );
            }
    }
    
    printf ("%d\n",used[x] - 1);
}

int main() {
    read();
    make_graph();
    solve();
    
    return 0;
}
