/*
TASK: square
LANG: C++
*/
#include <cstdio>
#include <vector>
#include <queue>
#define maxN (1024)

using namespace std;

typedef struct point {
        int x,y;
        } point;
      
int ori(point a, point b, point c)
{return a.x*(b.y-c.y)+b.x*(c.y-a.y)+c.x*(a.y-b.y);}

double orid(double ax, double ay,double bx, double by,double cx, double cy)
{return ax*(by-cy)+bx*(cy-ay)+cx*(ay-by);}
  
int n;
point sq[maxN][4];
vector <int> G[maxN];
queue < pair<int,int> > q;
char used[maxN];

void input()
{
     int xm,ym,xa,ya,x,y;
     int i,t;
     scanf("%d",&n);
     for (i=1;i<=n;++i) {
         scanf("%d%d%d%d",&xm,&ym,&xa,&ya);
         sq[i][0].x = xa; sq[i][0].y = ya;
         x = xa - xm; y = ya - ym;
         t = x; x = -y; y = t; sq[i][1].x = xm + x; sq[i][1].y = ym + y;
         t = x; x = -y; y = t; sq[i][2].x = xm + x; sq[i][2].y = ym + y;
         t = x; x = -y; y = t; sq[i][3].x = xm + x; sq[i][3].y = ym + y;
         }
}

void build()
{
     int i,j,p,q,ok1,ok2;
     double x,y;
     for (i=1;i<=n;++i) 
         for (j=1;j<=n;++j) if (i!=j) {
             for (p=0;p<4;++p) {
                 ok1 = ok2 = 1;
                 for (q=0;q<4;++q) if (ori(sq[j][q],sq[j][(q+1)%4],sq[i][p]) <= 0) {ok1=0;break;}
                 for (q=0;q<4;++q) {
                     x = ((double)sq[i][p].x + (double)sq[i][(p+1)%4].x) / 2.0;
                     y = ((double)sq[i][p].y + (double)sq[i][(p+1)%4].y) / 2.0;
                     if (orid((double)sq[j][q].x,(double)sq[j][q].y,(double)sq[j][(q+1)%4].x,(double)sq[j][(q+1)%4].y,x,y) <= 0.0) {ok2=0;break;}
                     }
                 if (ok1 || ok2) {
                         G[i].push_back(j);
                         G[j].push_back(i);
                         break;
                         }
                 }
             }
}

void bfs()
{
     int i;
     pair <int,int> p;
     q.push(make_pair(1,0)); used[1] = 1;
     while (!q.empty()) {
           p = q.front(); q.pop();
           if (p.first == n) {printf("%d\n",p.second); return;}
           for (i=0;i<G[p.first].size();++i) if (!used[G[p.first][i]]) {
               q.push(make_pair(G[p.first][i],p.second+1));
               used[G[p.first][i]] = 1;
               }
           }
     printf("-1\n");
}

int main()
{
    input();
    build();
    bfs();
    return 0;
}
