/*
TASK:square
LANG:C++
*/

#include<cstdio>
#include<vector>
#include<queue>

std::vector <std::vector <int> > G;
std::queue <int> Q;

int used[1024];

int n;

int bfs() {
	Q.push(0);
	used[0]=1;
	while( !Q.empty() ) {
		int a=Q.front();
		Q.pop();
		if(a==n-1) {return used[a];}
		for(int i=0;i<G[a].size();++i) {
			if(used[G[a][i]]==0) {
				Q.push(G[a][i]);
				used[G[a][i]]=used[a]+1;
			}
		}
	}
	return -1;
}

struct sq{
	int xa,ya,xm,ym;
}sqs[1024];

double ccw(double p0x,double p0y,double p1x,double p1y,double p2x,double p2y) {
	return (p1x-p0x)*(p2y-p0y)-(p2x-p0x)*(p1y-p0y);	
}
/*
bool cross(double a1x,double a1y,double a2x,double a2y,double b1x,double b1y,double b2x,double b2y) {
	if(ccw(a1x,a1y,a2x,a2y,b1x,b1y)*ccw(a1x,a1y,a2x,a2y,b2x,b2y)<0&&
	   ccw(b1x,b1y,b2x,b2y,a1x,a1y)*ccw(b1x,b1y,b2x,b2y,a2x,a2y)<0) return 1;
	return 0;	
}
*/
bool intersect(int p,int q) {
	double p1x,p1y,p2x,p2y,p3x,p3y,p4x,p4y;
	double q1x,q1y,q2x,q2y,q3x,q3y,q4x,q4y;
	
	p1x=sqs[p].xa;p1y=sqs[p].ya;
	p3x=2*sqs[p].xm-sqs[p].xa;p3y=2*sqs[p].ym-sqs[p].ya;
	p2x=sqs[p].xm+(p3y-sqs[p].ym);p2y=sqs[p].ym-(p3x-sqs[p].xm);
	p4x=sqs[p].xm-(p3y-sqs[p].ym);p4y=sqs[p].ym+(p3x-sqs[p].xm);
	
	q1x=sqs[q].xa;q1y=sqs[q].ya;
	q3x=2*sqs[q].xm-sqs[q].xa;q3y=2*sqs[q].ym-sqs[q].ya;
	q2x=sqs[q].xm+(q3y-sqs[q].ym);q2y=sqs[q].ym-(q3x-sqs[q].xm);
	q4x=sqs[q].xm-(q3y-sqs[q].ym);q4y=sqs[q].ym+(q3x-sqs[q].xm);
	
/*	if(cross(p1x,p1y,p2x,p2y,q1x,q1y,q2x,q2y)) return 1;
	if(cross(p1x,p1y,p2x,p2y,q2x,q2y,q3x,q3y)) return 1;
	if(cross(p1x,p1y,p2x,p2y,q3x,q3y,q4x,q4y)) return 1;
	if(cross(p1x,p1y,p2x,p2y,q4x,q4y,q1x,q1y)) return 1;
	
	if(cross(p2x,p2y,p3x,p3y,q1x,q1y,q2x,q2y)) return 1;
	if(cross(p2x,p2y,p3x,p3y,q2x,q2y,q3x,q3y)) return 1;
	if(cross(p2x,p2y,p3x,p3y,q3x,q3y,q4x,q4y)) return 1;
	if(cross(p2x,p2y,p3x,p3y,q4x,q4y,q1x,q1y)) return 1;	
	
	if(cross(p3x,p3y,p4x,p4y,q1x,q1y,q2x,q2y)) return 1;
	if(cross(p3x,p3y,p4x,p4y,q2x,q2y,q3x,q3y)) return 1;
	if(cross(p3x,p3y,p4x,p4y,q3x,q3y,q4x,q4y)) return 1;
	if(cross(p3x,p3y,p4x,p4y,q4x,q4y,q1x,q1y)) return 1;
	
	if(cross(p4x,p4y,p1x,p1y,q1x,q1y,q2x,q2y)) return 1;
	if(cross(p4x,p4y,p1x,p1y,q2x,q2y,q3x,q3y)) return 1;
	if(cross(p4x,p4y,p1x,p1y,q3x,q3y,q4x,q4y)) return 1;
	if(cross(p4x,p4y,p1x,p1y,q4x,q4y,q1x,q1y)) return 1;
*/	
	if(ccw(p1x,p1y,p2x,p2y,q1x,q1y)<=0 &&
	   ccw(p2x,p2y,p3x,p3y,q1x,q1y)<=0 &&
	   ccw(p3x,p3y,p4x,p4y,q1x,q1y)<=0 &&
	   ccw(p4x,p4y,p1x,p1y,q1x,q1y)<=0) return 1;
	
	if(ccw(p1x,p1y,p2x,p2y,q1x,q1y)>=0 &&
	   ccw(p2x,p2y,p3x,p3y,q1x,q1y)>=0 &&
	   ccw(p3x,p3y,p4x,p4y,q1x,q1y)>=0 &&
	   ccw(p4x,p4y,p1x,p1y,q1x,q1y)>=0) return 1;
	
	if(ccw(p1x,p1y,p2x,p2y,q2x,q2y)<=0 &&
	   ccw(p2x,p2y,p3x,p3y,q2x,q2y)<=0 &&
	   ccw(p3x,p3y,p4x,p4y,q2x,q2y)<=0 &&
	   ccw(p4x,p4y,p1x,p1y,q2x,q2y)<=0) return 1;
	
	if(ccw(p1x,p1y,p2x,p2y,q2x,q2y)>=0 &&
	   ccw(p2x,p2y,p3x,p3y,q2x,q2y)>=0 &&
	   ccw(p3x,p3y,p4x,p4y,q2x,q2y)>=0 &&
	   ccw(p4x,p4y,p1x,p1y,q2x,q2y)>=0) return 1;
	
	if(ccw(p1x,p1y,p2x,p2y,q3x,q3y)<=0 &&
	   ccw(p2x,p2y,p3x,p3y,q3x,q3y)<=0 &&
	   ccw(p3x,p3y,p4x,p4y,q3x,q3y)<=0 &&
	   ccw(p4x,p4y,p1x,p1y,q3x,q3y)<=0) return 1;
	
	if(ccw(p1x,p1y,p2x,p2y,q3x,q3y)>=0 &&
	   ccw(p2x,p2y,p3x,p3y,q3x,q3y)>=0 &&
	   ccw(p3x,p3y,p4x,p4y,q3x,q3y)>=0 &&
	   ccw(p4x,p4y,p1x,p1y,q3x,q3y)>=0) return 1;
	
	if(ccw(p1x,p1y,p2x,p2y,q4x,q4y)<=0 &&
	   ccw(p2x,p2y,p3x,p3y,q4x,q4y)<=0 &&
	   ccw(p3x,p3y,p4x,p4y,q4x,q4y)<=0 &&
	   ccw(p4x,p4y,p1x,p1y,q4x,q4y)<=0) return 1;
	
	if(ccw(p1x,p1y,p2x,p2y,q4x,q4y)>=0 &&
	   ccw(p2x,p2y,p3x,p3y,q4x,q4y)>=0 &&
	   ccw(p3x,p3y,p4x,p4y,q4x,q4y)>=0 &&
	   ccw(p4x,p4y,p1x,p1y,q4x,q4y)>=0) return 1;
	
	///////////////////////////
	if(ccw(q1x,q1y,q2x,q2y,p1x,p1y)<=0 &&
	   ccw(q2x,q2y,q3x,q3y,p1x,p1y)<=0 &&
	   ccw(q3x,q3y,q4x,q4y,p1x,p1y)<=0 &&
	   ccw(q4x,q4y,q1x,q1y,p1x,p1y)<=0) return 1;
	
	if(ccw(q1x,q1y,q2x,q2y,p1x,p1y)>=0 &&
	   ccw(q2x,q2y,q3x,q3y,p1x,p1y)>=0 &&
	   ccw(q3x,q3y,q4x,q4y,p1x,p1y)>=0 &&
	   ccw(q4x,q4y,q1x,q1y,p1x,p1y)>=0) return 1;
	
	if(ccw(q1x,q1y,q2x,q2y,p2x,p2y)<=0 &&
	   ccw(q2x,q2y,q3x,q3y,p2x,p2y)<=0 &&
	   ccw(q3x,q3y,q4x,q4y,p2x,p2y)<=0 &&
	   ccw(q4x,q4y,q1x,q1y,p2x,p2y)<=0) return 1;
	
	if(ccw(q1x,q1y,q2x,q2y,p2x,p2y)>=0 &&
	   ccw(q2x,q2y,q3x,q3y,p2x,p2y)>=0 &&
	   ccw(q3x,q3y,q4x,q4y,p2x,p2y)>=0 &&
	   ccw(q4x,q4y,q1x,q1y,p2x,p2y)>=0) return 1;
	
	if(ccw(q1x,q1y,q2x,q2y,p3x,p3y)<=0 &&
	   ccw(q2x,q2y,q3x,q3y,p3x,p3y)<=0 &&
	   ccw(q3x,q3y,q4x,q4y,p3x,p3y)<=0 &&
	   ccw(q4x,q4y,q1x,q1y,p3x,p3y)<=0) return 1;
	
	if(ccw(q1x,q1y,q2x,q2y,p3x,p3y)>=0 &&
	   ccw(q2x,q2y,q3x,q3y,p3x,p3y)>=0 &&
	   ccw(q3x,q3y,q4x,q4y,p3x,p3y)>=0 &&
	   ccw(q4x,q4y,q1x,q1y,p3x,p3y)>=0) return 1;
	
	if(ccw(q1x,q1y,q2x,q2y,p4x,p4y)<=0 &&
	   ccw(q2x,q2y,q3x,q3y,p4x,p4y)<=0 &&
	   ccw(q3x,q3y,q4x,q4y,p4x,p4y)<=0 &&
	   ccw(q4x,q4y,q1x,q1y,p4x,p4y)<=0) return 1;
	
	if(ccw(q1x,q1y,q2x,q2y,p4x,p4y)>=0 &&
	   ccw(q2x,q2y,q3x,q3y,p4x,p4y)>=0 &&
	   ccw(q3x,q3y,q4x,q4y,p4x,p4y)>=0 &&
	   ccw(q4x,q4y,q1x,q1y,p4x,p4y)>=0) return 1;
	
	return 0;	
}

int main() {
	scanf("%d",&n);
	G.resize(n+1);
	for(int i=0;i<n;++i) {
		scanf("%d%d%d%d",&sqs[i].xm,&sqs[i].ym,&sqs[i].xa,&sqs[i].ya);
	}
	for(int i=0;i<n;++i) {
		for(int j=i+1;j<n;++j) {
			if(intersect(i,j)) {
				G[i].push_back(j);
				G[j].push_back(i);	
			}	
		}	
	}

	
	printf("%d\n",bfs()-1);
	return 0;	
}
